/* Be::Query */
/* Copyright 1999 Tom Spindler */
/* This file is covered by the Artistic License. */
/* $Id: Query.xs,v 1.3 1999/05/03 19:12:29 dogcow Exp dogcow $ */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <dirent.h>
#include <be/storage/Query.h>
#include <be/kernel/fs_info.h>
#include <be/kernel/fs_query.h>

/* See http://www.be.com/documentation/be_book/The%20Storage%20Kit/QueryFuncs.html for more info on how the query stuff works. */

MODULE = Be::SimpleQuery          PACKAGE = Be::SimpleQuery

PROTOTYPES: ENABLE

void
SimpleQuery(volumepath, query)
        char * volumepath;
	char * query;
ALIAS:
	Be::SimpleQuery::SimpleQuery = 0
	Be::SimpleQuery = 1
PREINIT:
        DIR *q;
	dev_t d[256];
	char buf[PATH_MAX];
	dirent *de;
	int justone = 1;
	int i;
	int32 pos;
	char* query_formule;
	bool find_equal;
	bool quote_mode;
	bool quoting;
PPCODE:
	memset(d, 0, sizeof(d));
	if (strcmp("all", volumepath)) { /* nope, it's a pathname */
	  d[0] = dev_for_path(volumepath);
	} else { /* fill up the array with all the device numbers */
	  i = 0;
	  while(0 <= (d[i++] = next_dev(&pos))) {
	 	; /* we filled the array on the previous line */
	  }
	}		  
	
	query_formule = (char *)malloc(2);
	strcpy(query_formule, "*");

	
	i = 0;
	find_equal = 0;
	quote_mode = 0;
	quoting = 0;
	
	for (i; i<strlen(query); i++){
		if (quote_mode == 0){
			if (query[i] == '\\') quoting = 1;
			if ((quoting == 0) && (query[i] == '"')) quote_mode = 1;
			if ((quoting == 1) && (query[i] != '\\')) quoting = 0;
			
			query_formule = (char *)realloc(query_formule, strlen(query_formule)+2);
			if (i>0) sprintf(query_formule, "%s%c", query_formule, query[i]);
			else sprintf(query_formule, "%c", query[i]);
			
		}else{
			if (query[i] == '\\') quoting = 1;
			if ((quoting == 0) && (query[i] == '"')) quote_mode = 0;
			if ((quoting == 1) && (query[i] != '\\')) quoting = 0;
			
			if (isalpha(query[i]) != 0){
				query_formule = (char *)realloc(query_formule, strlen(query_formule)+5);
				sprintf(query_formule, "%s[%c%c]", query_formule, tolower(query[i]), toupper(query[i]));
			}else{
				query_formule = (char *)realloc(query_formule, strlen(query_formule)+2);
				sprintf(query_formule, "%s%c", query_formule, query[i]);
			}
		}
	}
	fprintf(stderr, "%s\n", query_formule);
	//query_formule = (char *)realloc(query_formule, strlen(query)+2);
	//strcat(query_formule, "*");
	
	
	i = 0;
	
	while (0 != d[i]) {
	  if (0 != (q = fs_open_query(d[i], query_formule, 0))) {
	    while (0 != (de = fs_read_query(q))) {
	      get_path_for_dirent(de, buf, PATH_MAX);
	      XPUSHs(sv_2mortal(newSVpv(buf, strlen(buf))));
	    }
	  }
	  i++;
	}
          
