#!/boot/home/config/bin/perl

use CGI qw(:standard);
require ('mp3_common.pl');

# get and parse settings using sub defined in mp3_common.pl file
&getsettings;

if ( param() )
{
	my @acceptable_values = ("ListDir","MyIPAddress");
	foreach $value (@acceptable_values)
	{
		# remember to check if value exists - otherwise blank info in config file.
		$prefs{$value} = param("$value") if (param("$value") ne "");
	}

}	

	
# The following was an attempt to make sure SoundPlay is running 
# before doing anything. It really should work as listed. It comes very close --
# it actually launches SoundPlay if it's not running, but it won't return 
# control back to the page. Suggestions?
#$Running = system("roster | grep application/x-vnd.marcone-soundplay");
#if ($Running eq 0) {
	# SoundPlay is running. Do nothing.
#} else {
# Edit this path to SoundPlay to match the path on your system.
#system ("/grueyer/apps/audio/SoundPlay-3.4/SoundPlay&");
#}




# SoundPlay won't accept the hey directive later in the script if
# it doesn't already have a track loaded. This section makes sure it 
# at least has a dummy track loaded. However, we only want to do this if no
# track is loaded, because if we do it all the time, the music stops playing when
# user returns to the base page. When creating the dummy track, we first delete
# track 0 because if we don't, SP will get an additional track on the stack each time the base
# page is reloaded, which would probably eventually cause it to run out of memory.
# Hey is used with -s flag to make it silent, so the shell doesn't return hey's output text
# into the page.

$RunningTrack = system("hey SoundPlay get name of track 0 | grep dummy");
if ($RunningTrack eq 1) {
	system("hey -s SoundPlay delete track 0");
	system("hey -s SoundPlay create track with name=dummy");
	}

# changes:

## shrunk volume and pitch-setting loop.
## changed message that sets pitch/volume so that it has more "variation" possible
## can't get negative pitch to work - this is even when using hey in the Terminal.  ??
## cut out extra call to hey in commands
## used the CGI module
## eliminated error reply message from hey...  I don't know how.
## changed directory scans
## messed with layout of program to make it look like I saved more space  :)

if ( param() )
{
	# is Robin Hood outputting the Content-type header for us?
	#print header; 
	$vol = param('Volume');
	$pitch = param('Pitch');
}

# No longer using this -- now getting settings from mp3_common.pl
# Where do you store your playlists?
#$ListDir = "/boot/home/betips/mp3box/playlists";

# Start of the HTML
print <<EOF;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>MP3box control base</title>
</head>
<body bgcolor="#191970">
<blockquote>

		
		<FORM ACTION="/cgi-bin/mp3_settings.pl">
		<font size="+2" color="#ffffff">MP3box Control Base</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE="Submit" VALUE="Configure MP3box">
		</FORM>


<table border=0 cellspacing=0 cellpadding=10 width=100%>	
	<tr>
		<td rowspan=2 BGCOLOR=#FFFFDA valign=top>
		<FORM ACTION="/cgi-bin/mp3_query.pl">
		<INPUT TYPE="submit" VALUE="New playlist">
		</FORM>
			<h3>Play a playlist</h3>
EOF

# Open and scan the directory containing playlists, insert linked list of lists


opendir(THELISTS,"$prefs{'ListDir'}");
@scan = grep !/^\.\.?$/, readdir THELISTS;
closedir(THELISTS);

foreach(@scan) 
{
	# Run voodoo on the space characters so they don't fail in the URL
	$SpacedList = "$_";
	$SpacedList =~ s/\ /%20/g;

	print "<a href=/cgi-bin/mp3_list.pl?List=$SpacedList>$_</a><BR>";	
}


print <<EOF;
		</td>	
		<td valign=top BGCOLOR=#83D1C5>
		<h3>Control SoundPlay</h3>
<a href="/cgi-bin/mp3_base.pl?Volume=$vol&Pitch=0.0"><img src="/mp3box/gfx/stop.gif" width=23 height=23 border=0 alt="stop"></a>
&nbsp; &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Volume=$vol&Pitch=1.0"><img src="/mp3box/gfx/play.gif" width=23 height=23 border=0 alt="play"></a>
<P>

<b>Volume</b><BR>
<a href="/cgi-bin/mp3_base.pl?Volume=0.0">Mute</a> 
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Volume=0.5">Low</a> 
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Volume=1.0">Normal</a> 
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Volume=1.5">Loud</a> 
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Volume=2.0">Eleven</a> 

<P>

<b>Pitch</b><BR>

<a href="/cgi-bin/mp3_base.pl?Pitch=-4.0">Blur Reverse</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=-2.0">Fast Reverse</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=-1.0">Reverse</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=-0.5">-50%</a>
<P>
<a href="/cgi-bin/mp3_base.pl?Pitch=4.0">Blur Forward</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=2.0">Fast Forward</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=1.0">Normal</a>
&nbsp; | &nbsp; 
<a href="/cgi-bin/mp3_base.pl?Pitch=0.5">+50%</a>


<P>

<b>Extra</b><BR>


<a href="http://$prefs{'MyIPAddress'}:8080">View SoundPlay's built-in HTTP list</a>


		</td>	
	</tr>

	<tr>
		<td valign=top bgcolor=#ADD8E6 vheight=100%>
			<h3>Browse directories</h3>

EOF

	# Take the BrowseDir variables and split them into a series of lines
	# we can treat independently
	@dir_list = split /\|/, $prefs{'BrowseDir'};
	
foreach(@dir_list)
	{
	#Take care of spaces in both directions
	$dirname = $_;
	$dirname =~ s/%20/\ /g;
	$linkname = $_;
	$linkname =~ s/\ /%20/g;
	print "<a href=\"/cgi-bin/mp3_browse.pl?Dir=$linkname&Current=$linkname\">$dirname</a><br>\n";
	}

print <<EOF;
			<pre>
						
						
			</pre>
		</td>	
	</tr>

<table>

</blockquote>
</body>
</html>

EOF


# Volume control routine
system "hey SoundPlay set volume of track 0 to $vol" if ($vol ne "");

# Pitch control routine
system "hey SoundPlay set pitch of track 0 to $pitch" if ($pitch ne "");



## subroutines

# The original version works beter - see coments below
# Die, outputting HTML error page 
# If no $title, use a default title 
sub HTMLdie { 
	local($msg,$title)= @_ ; 
         $title || ($title= "CGI Error") ; 


	print "Content-type: text/html\n\n" ; 
	print <<EOF; 
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
	<html>

	<head> 
		<title>$title</title> 
	</head> 
	<body> 
	
		<h1>$msg</h1> 
	</body> 
	</html> 
EOF

    exit ; 
}

