#!/boot/home/config/bin/perl


# Invoke the CGI.pm module with standard CGI functions.
# Guarantees perfect parsing, and much cleaner code
use CGI qw(:standard);


# We'll be needing to use the BFS perl module:
use Be::Attribute;


# Assign variables to data extracted from the URL
$Current = param("Current");
$DataPath = param("Dir");




# Define some simple HTML variables we can re-use later. Note that lots of HTML
# includes characters that need to be escaped, such as the < and > symbols.
# We avoid having to escape them by surrounding the variable text in quotes.
$highcell="<TD BGCOLOR=#FFFFDA>";
$lowcell="<TD BGCOLOR=#83D1C5>";

# The main contacts page alternates colors for readability. This variable
# will be toggled between the high and low colors after each record.
# We'll start with the low value.
$cellopen=$lowcell;

# HTML header data
print "Content-Type: text/html\n\n" ;

# Start of the HTML
print <<EOF; 

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>MP3Box: $DataPath</title>
</head>
</HEAD>
<BODY BGCOLOR="#FFFFFF" TEXT="#46528A" LINK="#46528A" VLINK="#46528A" >

<blockquote>

<b>Now playing:</b><BR>
$Current

		<FORM ACTION="/cgi-bin/mp3_base.pl">
		<INPUT TYPE="submit" VALUE="Return to base">
		</FORM>
<br>

</blockquote>


<center>
<TABLE WIDTH=95% BORDER=0 CELLPADDING=5 CELLSPACING=0>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Go</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Track/Folder</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Artist</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Album</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Genre</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Bitrate</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Length</b></FONT></TD>	
EOF


# Here's the meat. We open and close with the perl opendir and closedir functions.
# We build an open hook on the directory called ALLTRACKS that consists of the contents of 
# the datapath, then we build an array of the contents of that hook. Then we just
# loop through the contents of the array.
opendir(ALLTRACKS,$DataPath);
@scan=readdir(ALLTRACKS);

# Get the number of tracks in this directory. We can use this to give a 
# little report, but more importantly, we can use it to re-initialize
# SoundPlay with a dummy track, because an empty directory will cause
# it to lose its dummy track.
$NumFiles = $#scan;
# $NumFiles will equal one in an empty directory because the parent
# directory is being counted, so subtract one for an accurate count.
$NumFiles -= 1;


foreach(@scan)
{
	$MP3Node = Be::Attribute::GetBNode("$DataPath/$_");
	$Artist = Be::Attribute::ReadAttr($MP3Node, "Audio:Artist");
	$Title = Be::Attribute::ReadAttr($MP3Node, "Audio:Title");
	$Album = Be::Attribute::ReadAttr($MP3Node, "Audio:Album");	
	$Genre = Be::Attribute::ReadAttr($MP3Node, "Audio:Genre");
	$Bitrate = Be::Attribute::ReadAttr($MP3Node, "Audio:Bitrate");	
	$Length = Be::Attribute::ReadAttr($MP3Node, "Audio:Length");		
	$Icon = "/mp3box/gfx/swirl.gif border=0 width=23 height=21";	
	Be::Attribute::CloseNode ($MP3Node);


	# I've commented out this routine because I think it will be the key
	# to navigating around in directories. It's not functional yet, 
	# but there should be a way...
	
	# Removes the virtual directories ".." and "." from the  directory.
	# Prints certain email attributes to an easy to read table.
#	if ($_ eq ".") {
#		}
#	elsif ($_ eq "..") {
#		}
#	else {
	

	# Replaces any spaces in the string with %20, which stands in for the space character
	$ThisTrack = "$DataPath/$_";

		

	# Check to see if this entry is a dubdirectory.
	# If so, Make the Title column the dir name, and
	# blot out the rest of the attributes
	if (-d "$DataPath/$_") {
		$Title = "$_";
		$Artist = "";
		$Album = "";
		$Genre = "";
		$Bitrate = "";
		$Length = "";
		$Icon = "/mp3box/gfx/folderico2.gif width=22 height=20 border=0";
		}

	
print <<EOF;
	
		<TR VALIGN=BOTTOM>


			$cellopen<B>
			
EOF

# The user is going to click this link and the behavior will 
# be different depending on whether they're entering a
# directory or selecting an MP3 file. We get folder playing 
# for free because passing a directory ref to SoundPlay
# starts playing the files in that dir automatically.

# This is for directory links
	if (-d "$DataPath/$_") {
			$ThisTrack =~ s/\ /%20/g;
			print "<A HREF=\"mp3_browse.pl?Dir=$ThisTrack&Current=$ThisTrack\"><img src=$Icon></A>\n";
	}

# This is for track links
	else {
			$ThisTrack =~ s/\ /%20/g;
			$PathTemp = "$DataPath";
			$PathTemp =~ s/\ /%20/g;

			print "<A HREF=\"mp3_browse.pl?Dir=$PathTemp&Current=$ThisTrack\"><img src=$Icon></A>\n";
	}



print <<EOF;					

			</B></TD>
			
			$cellopen$Title</TD>

			$cellopen$Artist</TD>

			$cellopen$Album</TD>
			
			$cellopen$Genre</TD>

			$cellopen$Bitrate</TD>

			$cellopen$Length</TD>

		</TR>
	
EOF
		
		# To get alternating stripes on the index page, we Toggle the value of the 
		# cell highlighting variable back and forth, one toggle for each record.
		if ($cellopen eq $highcell) {
			$cellopen=$lowcell;
			}
		else {
			$cellopen=$highcell;
			}
		}
#}
closedir(ALLTRACKS);

# Finishes the HTML.
print <<EOF;

</TABLE>
</CENTER>

Files in this directory: $NumFiles


</BODY>
</HTML>

EOF


# Play the selected file
@ControlSP = ("hey", "-s", "SoundPlay", "set", "file", "of", "track", "dummy", "to", "file\($Current\)");
system (@ControlSP);

# This method does the same thing, but doesn't require the -s flag 
#my $output = qx#hey SoundPlay set file of track dummy to 'file($Current)'#;
  
#print "status: $?, output: $output";  


# If this is an empty directory, re-initialize SoundPlay with a dummy track.
if ("$NumFiles" eq "0") {
	system("hey -s SoundPlay create track with name=dummy")
	}



