#!/boot/home/config/bin/perl


# First, get the CGI variables from the URL into a list of strings 
# This invokes a subroutine at the bottom of the script
%cgivars= &getcgivars ; 


# We'll be needing to use the BFS perl module:
use Be::Attribute;




# Where playlists are stored
$ListDir = "/boot/home/betips/mp3box/playlists";


# Define some simple HTML variables we can re-use later. Note that lots of HTML
# includes characters that need to be escaped, such as the < and > symbols.
# We avoid having to escape them by surrounding the variable text in quotes.
$highcell="<TD BGCOLOR=#FFFFDA>";
$lowcell="<TD BGCOLOR=#83D1C5>";

# The main contacts page alternates colors for readability. This variable
# will be toggled between the high and low colors after each record.
# We'll start with the low value.
$cellopen=$lowcell;


# Assign variable names to be used in this script by parsing
# elements of the URL
$Current = "$cgivars{'Current'}";
$ThisList = "$cgivars{'List'}";
$ListPath = "$ListDir/$ThisList";



# HTML header data
print "Content-Type: text/html\n\n" ;

# Start of the HTML
print <<EOF; 

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>MP3Box: $ThisList</title>
</head>
</HEAD>
<BODY BGCOLOR="#FFFFFF" TEXT="#46528A" LINK="#46528A" VLINK="#46528A" >

<blockquote>

<P>
<b>
Playlist: <a href="/cgi-bin/mp3_list.pl?List=$ThisList">$ThisList</a><br>
Track: $Current
</b>
<P>
		<FORM ACTION="/cgi-bin/mp3_base.pl">
		<INPUT TYPE="submit" VALUE="Return to base">
		</FORM>
<br>

</blockquote>


<center>
<TABLE WIDTH=95% BORDER=0 CELLPADDING=5 CELLSPACING=0>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Go</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Track/Folder</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Artist</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Album</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Genre</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Bitrate</b></FONT></TD>
	<TD BGCOLOR=#46528A><FONT COLOR=#D0D7BB SIZE=+1><B>Length</b></FONT></TD>	




EOF




# Open the playlist file and read in each line. For each line,
# find corresponding file and get its attributes.

open (PL, "$ListPath");
while (<PL>) {
	chomp;	
#	print "$_<BR>\n";
	$MP3Node = Be::Attribute::GetBNode("$_");
	$Artist = Be::Attribute::ReadAttr($MP3Node, "Audio:Artist");
	$Title = Be::Attribute::ReadAttr($MP3Node, "Audio:Title");
	$Album = Be::Attribute::ReadAttr($MP3Node, "Audio:Album");	
	$Genre = Be::Attribute::ReadAttr($MP3Node, "Audio:Genre");
	$Bitrate = Be::Attribute::ReadAttr($MP3Node, "Audio:Bitrate");	
	$Length = Be::Attribute::ReadAttr($MP3Node, "Audio:Length");		
	$Icon = "/mp3box/gfx/swirl.gif border=0 width=23 height=21";	


# Run some voodoo on the filename to take care of spaces, 
# just like in play.pl
	$_ =~ s/\ /%20/g;
	$ThisList =~ s/\ /%20/g;

# In the following section, we invoke the $cellopen variable, which is set
# below and toggles back and forth between the alternately colored stripes.
# Then just insert variables into the page.
print <<EOF;
	
	<TR VALIGN=BOTTOM>


		$cellopen<a href="/cgi-bin/mp3_list.pl?List=$ThisList&Current=$_"><img src=$Icon></a></TD>

		$cellopen$Title</TD>

		$cellopen$Artist</TD>

		$cellopen$Album</TD>
		
		$cellopen$Genre</TD>

		$cellopen$Bitrate</TD>

		$cellopen$Length</TD>

	</TR>			
			
EOF

		# To get alternating stripes on the index page, we Toggle the value of the 
		# cell highlighting variable back and forth, one toggle for each record.
		if ($cellopen eq $highcell) {
			$cellopen=$lowcell;
			}
		else {
			$cellopen=$highcell;
			}

	}

print <<EOF;
</TABLE>
</CENTER>
</BODY>
</HTML>

EOF




# Play the selected list or file. Determine which to do by checking
# to see of the value $Current is empty or not

if ($Current eq "") {

	@ControlSP = ("hey", "-s", "SoundPlay", "set", "file", "of", "track", "dummy", "to", "file\($ListPath\)");
	system (@ControlSP);
	}
	else {
	@ControlSP = ("hey", "-s", "SoundPlay", "set", "file", "of", "track", "dummy", "to", "file\($Current\)");
	system (@ControlSP);
	}




#----------------- start of &getcgivars() module ---------------------- 

# Read all CGI vars into an associative array. 
# If multiple input fields have the same name, they are concatenated into 
#   one array element and delimited with the \0 character (which fails if 
#   the input has any \0 characters, very unlikely but conceivably possible). 
# Currently only supports Content-Type of application/x-www-form-urlencoded. 
sub getcgivars { 
    local($in, %in) ; 
    local($name, $value) ; 

    # First, read entire string of CGI vars into $in 
    if ( ($ENV{'REQUEST_METHOD'} eq 'GET') || 
         ($ENV{'REQUEST_METHOD'} eq 'HEAD') ) { 
        $in= $ENV{'QUERY_STRING'} ; 

    } elsif ($ENV{'REQUEST_METHOD'} eq 'POST') { 
        if ($ENV{'CONTENT_TYPE'}=~ m#^application/x-www-form-urlencoded$#i) { 
            $ENV{'CONTENT_LENGTH'} 
                || &HTMLdie("No Content-Length sent with the POST request.") ; 
            read(STDIN, $in, $ENV{'CONTENT_LENGTH'}) ; 

        } else { 
            &HTMLdie("Unsupported Content-Type: $ENV{'CONTENT_TYPE'}") ; 
        } 

    } else { 
        &HTMLdie("Script was called with unsupported REQUEST_METHOD.") ; 
    } 
    
    # Resolve and unencode name/value pairs into %in 
    foreach (split('&', $in)) { 
        s/\+/ /g ; 
        ($name, $value)= split('=', $_, 2) ; 
        $name=~ s/%(..)/chr(hex($1))/ge ; 
        $value=~ s/%(..)/chr(hex($1))/ge ; 
        $in{$name}.= "\0" if defined($in{$name}) ;  # concatenate multiple vars 
        $in{$name}.= $value ; 
    } 

    return %in ; 

} 

# The original version works beter - see coments below
# Die, outputting HTML error page 
# If no $title, use a default title 
sub HTMLdie { 
	local($msg,$title)= @_ ; 
         $title || ($title= "CGI Error") ; 


	print "Content-type: text/html\n\n" ; 
	print <<EOF; 
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
	<html>

	<head> 
		<title>$title</title> 
	</head> 
	<body> 
	
		<h1>$msg</h1> 
	</body> 
	</html> 
EOF

    exit ; 
}

