#!/boot/home/config/bin/perl

use CGI qw(:standard);
require ('mp3_common.pl');

print "Content-type:text/html\n\n";

# print HTML header
&html_header("MP3box Configurator");

# get settings using sub defined in mp3_common.pl file
&getsettings;

# print cheesy navigation bar
#&print_nav_bar;

# write settings to file if they have been changed (i.e. data is being submitted)
# it would be possible to loop over whatever values are being sent in, but it's 
# better not to do so, as that could allow someone to arbitrarily write data to the 
# settings file.
if ( param() )
{
	my @acceptable_values = ("ListDir","QueryDir","MyIPAddress");
	foreach $value (@acceptable_values)
	{
		# remember to check if value exists - otherwise blank info in config file.
		$prefs{$value} = param("$value") if (param("$value") ne "");
	}
	
	# the browsing directories are a special case, as it's 
	# (saved as) multiple items in a pipe-delimited list.	
	unless (param('BrowseDir') eq "")
	{
		$browselist = join '|', split /\n/, param('BrowseDir'); 
		$browselist =~ s/\n//go;
		$browselist =~ s/\r//go;
		$browselist =~ s/\|\|/|/go; # takes care of blank lines
		
		$prefs{'BrowseDir'} = "$browselist";
	}	
	
	# write changed prefs to file.
	open (CONFIGFILE, ">/boot/home/config/settings/mp3box_settings") 
		or print "<P>cannot open /boot/home/config/settings/mp3box_settings: $!<P>";
	foreach $config_val (keys %prefs)
	{
		print CONFIGFILE "$config_val = $prefs{$config_val}\n"	
	}
	close CONFIGFILE;
}


# create readable version of browselist for HTML below.
$readable_list = join "\n", (split /\|/, $prefs{'BrowseDir'});

# print HTML for settings.
print <<EOF
	
<FORM ACTION="/cgi-bin/mp3_settings.pl" METHOD="POST"> 
	<TABLE BORDER=0 BGCOLOR="#CCCCCC" ALIGN=CENTER> 
	<TR>
		<TD VALIGN=top ALIGN=right><font color="#000000">Playlist Directory: </font><BR></TD> 
		<TD VALIGN=top><INPUT TYPE="text" NAME="ListDir" VALUE="$prefs{'ListDir'}" SIZE="45"><BR></TD>
	</TR>
	<TR>
		<TD VALIGN=top ALIGN=right><font color="#000000">Default Query Volume: </font><BR></TD> 
		<TD VALIGN=top><INPUT TYPE="text" NAME="QueryDir" VALUE="$prefs{'QueryDir'}" SIZE="45"><BR></TD>
	</TR>
	<TR>
		<TD VALIGN=top ALIGN=right><font color="#000000">IP or domain of mp3box server:</font><BR></TD>   
        <TD VALIGN=top><INPUT TYPE="text" NAME="MyIPAddress" VALUE="$prefs{'MyIPAddress'}" SIZE="20"><BR></TD>
	</TR>
	<TR>
		<TD VALIGN=top ALIGN=right><font color="#000000">Browsing directories (one to a line):</font><BR>    </TD> 
		<TD VALIGN=top><TEXTAREA COLS=45 ROWS=5 NAME="BrowseDir">$readable_list</TEXTAREA><BR></TD>
	</TR>

		<TD ALIGN=center COLSPAN=2>
		<INPUT TYPE="Submit" VALUE="Update settings">
		

		<P>
		<font color="#000000">(Please allow 40 seconds for processing -- we're working on this bug...)</font>
		</TD>
	</TR> 
</TABLE> 
</FORM> 

<blockquote>
<blockquote>
<blockquote>
		<FORM ACTION="/cgi-bin/mp3_base.pl">
		<INPUT TYPE="Submit" VALUE="Return to Base">
		</FORM>
</blockquote>
</blockquote>
</blockquote>

		
</blockquote>
</body>
</html>
EOF
